
import OFS
from OFS import SimpleItem
import Globals
from Globals import DTMLFile
import urllib
import string
import re
from email.Utils import *


class AddressBook(OFS.Folder.Folder) :
    "an AddressBook Folder"

    
    meta_type = 'Emil_AddressBook'
    manage_options = ( {'label': 'view',   'action': 'index_html',},
		       {'label': 'import',   'action': 'import_html',},
		       
		       )

    __ac_permissions__=(
	('View management screens',['manage_editForm',
				    'manage_editAction',
				    'manage_importAddressBook',
				    'manage_write_email_to_selected'], ('Owner',)),
	('View',  	           ['index_html','import_html'],			    ('Owner',)),     
        )     
    
    index_html         = DTMLFile('dtml/adrbook/addressbook_index_html'      , globals())
    import_html        = DTMLFile('dtml/adrbook/addressbook_import_html'      , globals())
    
    def __init__(self,id,title) :
	self.id    = id
	self.title = title
	
    def manage_main(trueself,self,REQUEST=None,update_menu=0,cb_dataValid=0,manage_tabs_message=None):
	""" wrapper around manage_main """
	return self.index_html(REQUEST,update_menu,cb_dataValid,manage_tabs_message)


    def get_addresses(self) :
	""" returns list of address objects """
	return self.objectItems('Emil_address')

    def manage_importAddressBook(self,file_type, REQUEST=None) :
	""" import data from external email client """

	if file_type != 'kmail' :
	    message = "import from %s not supported" % file_type
	    return self.import_html(REQUEST,manage_tabs_message=message)

	file = REQUEST.form['attached_file']
	
	for line in string.split(file,"\n") :
	    if line == "" : continue
	    if re.match("^#",line) :
		# commented line, skip it
		continue
	    # check for correct format of line
	    # very simple check hm.
	    match = re.match(".*@.*",line)
	    if match == None :		
		print "can not parse line >%s<" % line
		continue

	    # some problems with parseaddr require this:
	    try:
		spl = string.split(line,"<")
		realname = spl[0]
		email = spl[1]
		r, address  = parseaddr(email)
	    except:
		# something stupid happened, catch this case...
		# user will have to format this address entry himself...
		realname = line
	    #print line
	    #print ">%s<,>%s<" % (realname, address)
	    manage_addAddress(self,firstname=realname,email=address)
	    #return self.index_html(REQUEST)
	message = "addressbook successfully imported"
	return self.index_html(REQUEST,manage_tabs_message=message)

    def manage_write_email_to_selected(self,ids=[],REQUEST=None,RESPONSE=None) :
	""" send email to selected addresses from adress book """

	to = ""
	c = 0
	for id in ids :
	    c = c + 1
	    obj = getattr(self,id)
	    adr = obj.__str__()
	    if c > 1 :
		to += ","
	    to += adr
	
	if RESPONSE != None :
	    # return method of higher level email folder
	    url = REQUEST['URL2']
	    print url
	    path = urllib.urlencode({'To':to})
	    npath = url + '/folder_write_mail_html?' + path	    
	    return REQUEST.RESPONSE.redirect(npath)
	return self.folder_write_mail_html(To=to)
    



	    
manage_addAddressbookForm = DTMLFile('dtml/adrbook/addressbook_Add',globals())
	
def manage_addAddressBook(self,id,title,REQUEST=None) :
    """ add an address book"""
    
    self._setObject(id,AddressBook(id,title))
    if REQUEST is not None: return self.manage_main(self,REQUEST)

    

class Address(SimpleItem.SimpleItem):
    """ an address entry """

    meta_type = "Emil_address"
    
    manage_options = (
	{'label': 'View',          'action': 'index_html'},
	{'label': 'Edit',          'action': 'manage_editForm'},
	)

    __ac_permissions__=(
	('View', ['index_html',], ('Owner',)),
	('View management screens',['manage_editForm',], ('Owner',)),
        ) 

    index_html        = DTMLFile('dtml/adrbook/address_index_html'    , globals())
    manage_editForm   = DTMLFile('dtml/adrbook/address_editForm_html' , globals())
    
    def __init__(self,id,firstname,lastname,nickname,email) :
	""" initialize address """
	self.id        = id 
	self.firstname = firstname
	self.lastname  = lastname
	self.nickname  = nickname
	self.email     = email

    def address_editAddressAction(self,firstname,lastname,nickname,email, REQUEST=None,RESPONSE=None):
	""" edit address"""
	self.firstname = firstname
	self.lastname  = lastname
	self.nickname  = nickname
	self.email     = email
	self._p_changed = 1
	self.update_address_table()
	message = "properties have been changed"
	return self.index_html(self, REQUEST,manage_tabs_message=message)

    def html_display(self,field) :
	""" html representation of email"""
	name = "%s %s" % (self.firstname,self.lastname)
	if name == "" :
	    return self.email
	else :
	    str = name +" <%s>" % self.email
	    return urllib.urlencode({field:str})
	    
	
    def __str__(self):
	""" string representation of message """
	name = "%s %s" % (self.firstname,self.lastname)
	if name == "" :
	    str = self.email
	else :
	    str = "%s <%s>" % (name,self.email)
	return str

    def get_nickname(self):
	return self.nickname

    def get_email(self):
	return self.email
    
manage_addAddressForm = DTMLFile('dtml/adrbook/address_manageAddForm_html',globals())
	
def manage_addAddress(self,firstname='',lastname='',nickname='',email='',REQUEST=None) :
    """ add an address """

    id = self.create_unique_id()	
  
    self._setObject(id,Address(id,firstname,lastname,nickname,email))

    self.update_address_table()	
    if REQUEST is not None:
	url = REQUEST['URL3']
	return REQUEST.RESPONSE.redirect(url)
    return self.index_html(self,REQUEST)

